/* Rather limited shell printf function for maximally 9 arguments.
   Compile: cc -O2 -Wall -o printf myprintf.c
   Don't forget to export PATH=.:"$PATH" to use it.

   Copyright (C) 2002  J.A. Bezemer  <J.A.Bezemer@opensourcepartners.nl>
   Licensed under the GNU General Public License, version 2 exactly.
*/

#include <stdio.h>
#include <stdlib.h>
/* Maybe you also need
   #include <math.h>
   (and then probably add `-lm' to the compile command)
*/

int
main (argc, argv)
     int argc;
     char **argv;
{
  char buf[200];
  int i, j;

  if (argc < 2)
    return 1;

  for (i = 0, j = 0; argv[1][i]; i++, j++)
    if (i > 0 && argv[1][i - 1] == '\\')
      {
	if (argv[1][i] == 'n')
	  {
	    j--;
	    buf[j] = '\n';
	  }
	else if (argv[1][i] == 'r')
	  {
	    j--;
	    buf[j] = '\r';
	  }
	else
	  buf[j] = argv[1][i];
      }
    else
      buf[j] = argv[1][i];
  buf[j] = 0;

  if (argc >= 2 && argv[1][0] == '%' && argv[1][1] == '3'
      && argv[1][2] == 'd')
    printf (buf, argc >= 3 ? atoi (argv[2]) : 0,
	    argc >= 4 ? argv[3] : NULL, argc >= 5 ? argv[4] : NULL,
	    argc >= 6 ? argv[5] : NULL, argc >= 7 ? argv[6] : NULL,
	    argc >= 8 ? argv[7] : NULL, argc >= 9 ? argv[8] : NULL,
	    argc >= 10 ? argv[9] : NULL);
  else
    printf (buf, argc >= 3 ? argv[2] : NULL,
	    argc >= 4 ? argv[3] : NULL, argc >= 5 ? argv[4] : NULL,
	    argc >= 6 ? argv[5] : NULL, argc >= 7 ? argv[6] : NULL,
	    argc >= 8 ? argv[7] : NULL, argc >= 9 ? argv[8] : NULL,
	    argc >= 10 ? argv[9] : NULL);

  return 0;
}
